//*********************************************
// Student Name: Ruchir Doshi
// Student Number: 20295912
//
// SD 121 Lab: 09 Assignment: 02
//
// Filename: Date.cpp
// Date submitted: November 23, 2009
//
// I hereby declare that this code, submitted
// for credit for the course SD121, is a product
// of my own efforts. This coded solution has
// not been plagiarized from other sources and
// has not been knowingly plagiarized by others.
//
// Signed,
//
//
// Ruchir Doshi
//*********************************************

// Project: Rational
// File: Rational.cpp

#include "Rational.h"

Rational::Rational()
: is_valid_( false ), num ( 1 ), den ( 1 )
{
}

Rational::Rational( const int init_num, const int init_den )
: num( init_num ), den( init_den )
{
    if ( den == 0)
        is_valid_ = false;
    else if (den == 0 && num == 0)
        is_valid_ = false; 
    else
        is_valid_ = true;
}

bool Rational::is_valid() const
{
    return is_valid_;
}

void Rational::check() const
{
    if ( ! ( is_valid() ) )
	{
		cout << "Indeterminate form of rational." << endl;
		system("pause");
        exit(1);
	}
}          

int Rational::get_num() const
{
   check();
   return num;
}

int Rational::get_den() const
{
   check();
   return den;
}      

int Rational::gcd()
{
    int a = num;
    int b = den;
    int tmp;
    // While b is not 0
    while (b)
    {
          tmp = b;
          b = a % b;
          a = tmp;
    }
    
    return a;
}

void Rational::reduce()
{
     // Get the greatest common divisor
     int gcdNum = gcd();
     // If there is a common divisor, we don't want to divide by 0
     if(gcdNum != 0)
     {
               // Set the new numerator
               num = num / gcdNum;
               // Set the new denominator
               den = den / gcdNum;
     }
}

void Rational::printRational() const
{
    if ( is_valid() )
    {
        cout << num << '/' << den << endl;;
    }
    else
        cout << "NUMBER_INDETERMINATE" << endl;
}

void Rational:: printRationalAsFloating() const
{
     if ( is_valid() )
          cout << float(num)/den << endl;
     else
          cout << "NUMBER_INDETERMINATE" << endl;
}
         
Rational Rational::addition ( const Rational &a )
{
         Rational add;
         add.num = (num * a.num) + (den * a.num);
         add.den = (den * a.den);
         check();
         reduce();
         return add;
}

Rational Rational::subtraction ( const Rational &a )
{
         Rational sub;
         sub.num = (num * a.num) - (den * a.num);
         sub.den = (den * a.den);
         check();
         reduce();
         return sub;
}

Rational Rational::multiplication ( const Rational &a )
{
         Rational multi;
         multi.num = (num * a.num);
         multi.den = (den * a.den);
         check();
         reduce();
         return multi;
}

Rational Rational::division ( const Rational &a )
{
         Rational div;
         div.num = (num * a.den);
         div.den = (den * a.num);
         check();
         reduce();
         return div;
}
